-------------------------------------------------------------
--  fa.vhd - full adder
-------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity FA is
    port (A : in std_logic;
          B : in std_logic;
          Cin: in std_logic;
          Cout: out std_logic;
          S   : out std_logic
         );
end FA;         
architecture RTL of FA is
    signal X : std_logic;
begin
    X <= A xor B after 1 ns;
    S <= X xor Cin after 1 ns;
    Cout <= (A and B) or (A and Cin) or (B and Cin) after 2 ns;
end;
             
